//
//  AutoComplateReponseDto.swift
//  goong-sample-mapLibre-ios
//
//  Created by macos on 10/6/24.
//

import Foundation

struct AutoComplete: Codable {
    let predictions: [Prediction]
      let executionTime, status: String

      enum CodingKeys: String, CodingKey {
          case predictions
          case executionTime = "execution_time"
          case status
      }
  }

  // MARK: - Prediction
  struct Prediction: Codable {
      let description: String
      let matchedSubstrings: [MatchedSubstring]
      let placeID, reference: String
      let structuredFormatting: StructuredFormatting
      let hasChildren: Bool
      let plusCode: PlusCode
      let compound: Compound
      let terms: [Term]
      let types: [String]
      let distanceMeters: Int

      enum CodingKeys: String, CodingKey {
          case description
          case matchedSubstrings = "matched_substrings"
          case placeID = "place_id"
          case reference
          case structuredFormatting = "structured_formatting"
          case hasChildren = "has_children"
          case plusCode = "plus_code"
          case compound, terms, types
          case distanceMeters = "distance_meters"
      }
  }

  // MARK: - Compound
  struct Compound: Codable {
      let district, commune, province: String?
  }

  // MARK: - MatchedSubstring
  struct MatchedSubstring: Codable {
      let length, offset: Int
  }

  // MARK: - PlusCode
  struct PlusCode: Codable {
      let compoundCode, globalCode: String

      enum CodingKeys: String, CodingKey {
          case compoundCode = "compound_code"
          case globalCode = "global_code"
      }
  }

  // MARK: - StructuredFormatting
  struct StructuredFormatting: Codable {
      let mainText: String
      let mainTextMatchedSubstrings: [MatchedSubstring]
      let secondaryText: String
      let secondaryTextMatchedSubstrings: [MatchedSubstring]

      enum CodingKeys: String, CodingKey {
          case mainText = "main_text"
          case mainTextMatchedSubstrings = "main_text_matched_substrings"
          case secondaryText = "secondary_text"
          case secondaryTextMatchedSubstrings = "secondary_text_matched_substrings"
      }
  }

  // MARK: - Term
  struct Term: Codable {
      let offset: Int
      let value: String
  }
