//
//  DirectionViewModel.swift
//  goong-sample-mapLibre-ios
//
//  Created by macos on 10/6/24.
//

import Foundation

final class DirectionViewModel: ObservableObject {
    var onDirectionUpdate: (()->Void)?
    @Published var direction: DirectionReponseDto!
    {
        didSet {
            self.onDirectionUpdate?()
        }
    }
    var onStatusLineUpdate: (()->Void)?
    @Published var status:Bool!{
        didSet{
                self.onStatusLineUpdate?()
        }
    }
    var url: String = ""
    
    func ConvertURL(origin:String, destination:String ){
        url = "\(GoongConstants.GOONG_API_URL)/Direction?vehicle=car&origin=\(origin)&destination=\(destination)&alternatives=true&api_key=\(GoongConstants.GOONG_API_KEY)"
        getDirection()
    }
    func getDirection(){
        weak var task: DispatchWorkItem?
        DispatchQueue.global().async {
            var request = URLRequest(url: URL(string: self.url)!)
            request.httpMethod = "GET"
            request.addValue("application/json", forHTTPHeaderField: "Content-Type")
            let session = URLSession.shared
            let task = session.dataTask(with: request, completionHandler: {[weak self] data, response, error -> Void in
                do {
                    let json = try JSONDecoder().decode(DirectionReponseDto.self, from: data!)
                    DispatchQueue.main.async {
                        self?.direction = json
                        task?.cancel()
                    }
                } catch {
                    print("Error: \(error)")
                }
            })
            task.resume()
        }
    }
}
