//
//  PlaceDetailViewModel.swift
//  goong-sample-mapLibre-ios
//
//  Created by macos on 10/6/24.
//

import Foundation
import CoreLocation

final class PlaceDetailViewModel: ObservableObject {
    var onLocationUpdate: (()->Void)?
    @Published var locationDetail: LocationReponseDto?{
        didSet {
            self.onLocationUpdate?()
        }
    }
    private var url: String = ""
    
    func ConvertURL(placeID:String){
        url = "\(GoongConstants.GOONG_API_URL)/Place/Detail?place_id=\(placeID)&api_key=\(GoongConstants.GOONG_API_KEY)"
        fetchPlaceDetail()
    }
    
    func fetchPlaceDetail(){
        weak var task: DispatchWorkItem?
        DispatchQueue.global().async {
            var request = URLRequest(url: URL(string: self.url)!)
            request.httpMethod = "GET"
            request.addValue("application/json", forHTTPHeaderField: "Content-Type")
            
            let session = URLSession.shared
            let task = session.dataTask(with: request, completionHandler: {[weak self] data, response, error -> Void in
                do {
                    let json = try JSONDecoder().decode(LocationReponseDto.self, from: data!)
                    DispatchQueue.main.async {
                        self?.locationDetail = json
                        task?.cancel()
                    }
                } catch {
                    print("Error: \(error)")
                }
            })
            task.resume()
        }
    }
}
