//
//  SearchViewModel.swift
//  goong-sample-mapLibre-ios
//
//  Created by macos on 10/6/24.
//

import Foundation
import CoreLocation

final class SearchViewModel: ObservableObject {
    @Published var searchText: String = ""
    @Published var searchFavourite: String = ""
    
    @Published var predictions: AutoComplete?
    @Published var statusSearch = false
    private var inputText: String = ""
    private var url: String = ""
    
    func ConvertURL(currentLocation: CLLocationCoordinate2D, searchText:String){
        inputText =  searchText.addingPercentEncoding(withAllowedCharacters: .urlQueryAllowed)!
        url = "\(GoongConstants.GOONG_API_URL)/Place/AutoComplete?api_key=\(GoongConstants.GOONG_API_KEY)&location=\(currentLocation.latitude),\(currentLocation.longitude)&input=\(inputText)&origin=\(currentLocation.latitude),\(currentLocation.longitude)"
        if (searchText.count > 3) {
            fetchAPISearch()
        }
    }
    
    func fetchAPISearch(){
        weak var task: DispatchWorkItem?
        DispatchQueue.global().async {
            var request = URLRequest(url: URL(string: self.url)!)
            request.httpMethod = "GET"
            request.addValue("application/json", forHTTPHeaderField: "Content-Type")

            let session = URLSession.shared
            let task = session.dataTask(with: request, completionHandler: {[weak self] data, response, error -> Void in
                if let response = response as? HTTPURLResponse {
                    do {
                        let json = try JSONDecoder().decode(AutoComplete.self, from: data!)
                        DispatchQueue.main.async {
                            self?.predictions = json
                            task?.cancel()
                        }
                    } catch {
                        print("error",error)
                    }
                }
            })
            task.resume()
        }
    }
}
